GTPin: gtpin::IGtProfileBuffer Class Reference

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
gtpin::IGtProfileBuffer Class Reference
Profile Buffer

Abstract representation of the profile data storage. More...

`#include <igt_profile_buffer.h>`

## Public Member Functions
virtual uint32_t | Size () const =0
| Return size of the profile buffer, in bytes.
virtual bool | Read (uint32_t offset, void *dst, uint32_t size) const =0
| Copy memory block from the profile buffer into specified host memory location.
virtual bool | Write (uint32_t offset, const void *src, uint32_t size)=0
| Copy memory block from the specified host memory location into profile buffer.
virtual bool | Fill (uint32_t offset, uint32_t size, uint8_t val)=0
| Assign the given value to all bytes of the specified memory block within profile buffer.
virtual bool | Fill (uint8_t val=0)=0
| Assign the given value to all bytes of this profile buffer.
virtual GtDeviceAddr | DeviceAddr (uint32_t offset=0) const =0
| Given offset within profile buffer, get virtual address of the corresponding device memory location.

## Detailed Description

Abstract representation of the profile data storage.

Availability:
  - IGtTool::OnKernelRun
  - IGtTool::OnKernelComplete

## Member Function Documentation

virtual GtDeviceAddr gtpin::IGtProfileBuffer::DeviceAddr | ( | uint32_t | offset = `0` | ) | const`[pure virtual]`

Given offset within profile buffer, get virtual address of the corresponding device memory location.

Parameters:

  [in] | offset | Offset of the location within profile buffer

Returns:
  Address in the virtual address space of the device, or invalid address if offset > Size()

virtual bool gtpin::IGtProfileBuffer::Fill | ( | uint8_t | val = `0` | ) | `[pure virtual]`

Assign the given value to all bytes of this profile buffer.

Parameters:

  [in] | val | The value to be assigned

Returns:
  true - success, false - failure In case of error, the IGtCore::LastError() function provides the specific failure reason

virtual bool gtpin::IGtProfileBuffer::Fill | ( | uint32_t | offset,
|  | uint32_t | size,
|  | uint8_t | val
| ) |  | `[pure virtual]`

Assign the given value to all bytes of the specified memory block within profile buffer.

Parameters:

  [in] | offset | Offset of the memory block within profile buffer
  [in] | size | Number of bytes to fill in
  [in] | val | The value to be assigned

Returns:
  true - success, false - failure In case of error, the IGtCore::LastError() function provides the specific failure reason

virtual bool gtpin::IGtProfileBuffer::Read | ( | uint32_t | offset,
|  | void * | dst,
|  | uint32_t | size
| ) |  | const`[pure virtual]`

Copy memory block from the profile buffer into specified host memory location.

Parameters:

  [in] | offset | Offset of the memory block within profile buffer
  [in,out] | dst | Destination address in the host memory
  [in] | size | Number of bytes to copy

Returns:
  true - success, false - failure In case of error, the IGtCore::LastError() function provides the specific failure reason

virtual bool gtpin::IGtProfileBuffer::Write | ( | uint32_t | offset,
|  | const void * | src,
|  | uint32_t | size
| ) |  | `[pure virtual]`

Copy memory block from the specified host memory location into profile buffer.

Parameters:

  [in] | offset | Offset of the memory block within profile buffer
  [in] | src | Source address in the host memory
  [in] | size | Number of bytes to copy

Returns:
  true - success, false - failure In case of error, the IGtCore::LastError() function provides the specific failure reason

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT